/**
 * Created by robin on 10/24/15.
 */

(function () {
    'use strict';
    angular.module('luticate2Utils')
        .factory('luRequest', ['$q', '$http', 'luBusyBusiness', function ($q, $http, luBusyBusiness) {

            var luRequest = {};

            luRequest.get = function(url, dataGet, luBusyGroups)
            {
                return luRequest.request(url, 'GET', dataGet, null, luBusyGroups);
            };

            luRequest.post = function(url, dataGet, dataPost, luBusyGroups)
            {
                return luRequest.request(url, 'POST', dataGet, dataPost, luBusyGroups);
            };

            luRequest.put = function(url, dataGet, dataPost, luBusyGroups)
            {
                return luRequest.request(url, 'PUT', dataGet, dataPost, luBusyGroups);
            };

            luRequest.delete = function(url, dataGet, dataPost, luBusyGroups)
            {
                return luRequest.request(url, 'DELETE', dataGet, dataPost, luBusyGroups);
            };

            function reject(deferred, data, status, luBusyGroups)
            {
                var error = {
                    data: data,
                    status: status
                };
                deferred.reject(error);
                if (luBusyGroups != null) {
                    luBusyBusiness.reject(luBusyGroups, error);
                }
            }

            function resolve(deferred, data, luBusyGroups)
            {
                deferred.resolve(data);
                if (luBusyGroups != null) {
                    luBusyBusiness.resolve(luBusyGroups);
                }
            }

            luRequest.request = function(url, method, dataGet, dataPost, luBusyGroups)
            {
                if (luBusyGroups != null) {
                    luBusyBusiness.initGroups(luBusyGroups);
                }
                
                var deferred = $q.defer();

                url = url.replace(/\/+$/, '');

                var params = {
                    url: url,
                    method: method,
                    params: dataGet,
                    data: JSON.stringify(dataPost),
                    headers: {
                        'Content-Type': "application/json"
                    }
                };

                $http(params)
                    .then(function (response) {
                        var result = response.data;
                        var status = response.status;
                        if (result == null || typeof result !== 'object') {
                            reject(deferred, {message: "Failed to parse response", code: status}, status, luBusyGroups);
                        }
                        else if (result.message != null) {
                            reject(deferred, result, status, luBusyGroups);
                        }
                        else {
                            resolve(deferred, result.data, luBusyGroups);
                        }
                    }, function (response) {
                        var result = response.data;
                        var status = response.status;
                        if (result == null || typeof result !== 'object') {
                            reject(deferred, {message: "Failed to parse response", code: status}, status, luBusyGroups);
                        }
                        else {
                            reject(deferred, result, status, luBusyGroups);
                        }
                    });
                return deferred.promise;
            };

            return luRequest;
        }]);
})();
